jQuery(document).ready(function($) {


  function textChangeListener(evt){
    var id = evt.target.id;
    var text = evt.target.value;
    
    if (id == "qcilist_pro_meme_toplinetext") {
      window.qcilist_pro_meme_toplinetext = text;
    } else {
      window.qcilist_pro_meme_bottomlinetext = text;
    }
    
    redrawMeme(window.imageSrc, window.qcilist_pro_meme_toplinetext, window.qcilist_pro_meme_bottomlinetext);
  }
  //------
  function redrawMeme(image, topLine, bottomLine) {
    // Get Canvas2DContext
    var canvas = document.querySelector('canvas');
    var ctx = canvas.getContext("2d");
    if (image != null)
      ctx.drawImage(image, 0, 0, canvas.width, canvas.height);
    
    // clear previous
    ctx.clearRect(0, 0, canvas.width, canvas.height);
    
    if (image != null)
			ctx.drawImage(image, 0, 0, canvas.width, canvas.height);
    
    // Text attributes
    ctx.font = '20pt Impact';
    ctx.textAlign = 'center';
    ctx.strokeStyle = 'black';
    ctx.lineWidth = 3;
    ctx.fillStyle = 'white';
    
    if (topLine != null) {
      ctx.fillText(topLine, canvas.width / 2, 40);
      ctx.strokeText(topLine, canvas.width / 2, 40);
    }
    
    if (bottomLine != null) {
      ctx.fillText(bottomLine, canvas.width / 2, canvas.height - 20);
      ctx.strokeText(bottomLine, canvas.width / 2, canvas.height - 20);
    }

  }
    
  function saveFileData(){

    html2canvas($("#qcilist_pro_meme_canvas_wrao"), { 
        onrendered: function(canvas) { 
          var imgsrc = canvas.toDataURL("image/png"); 
          //var dataURL = canvas.toDataURL("image/png"); 
          var dataURL = canvas.toDataURL("image/png").replace("image/png", "image/octet-stream"); 
          $('#qcilist_pro_meme_canvas_img').val('');
          $('#qcilist_pro_meme_canvas_img').val(dataURL);

          var meme_data_set = $('#qcilist_pro_meme_build .qcilist_pro_meme_canvas_wrap').html();
          $('.qcld_ilist_meme_publish_in_data').val('');
          $('.qcld_ilist_meme_publish_in_data').val(meme_data_set);

          //console.log( meme_data_set );

        } 
      });

  }


  $(document).on('click', '.qcld_ilist_meme_image_upload', function(e){
    e.preventDefault();

    var image = wp.media({
                title: 'Meme Image',
                multiple: false
            }).open().on('select', function(e){

      var uploaded_image = image.state().get('selection').first();
      var image_url = uploaded_image.toJSON().url;

      $("#qcilist_pro_meme_canvas_img_path").attr('src', image_url); 
      $("#qcilist_pro_meme_canvas_img_path").show();

      saveFileData();

    });

  });

  $(document).on('click', '.qcld-meme-pixel-photo_added', function(e){
      e.preventDefault();
      var currentDom = $(this);
      var image_url = $(this).find('img').data('img');
      var image_page_url = $(this).find('img').data('url');
      var photographer = $(this).find('img').data('photographer');

        // loading animation
        currentDom.addClass('uploading').find('.download img').replaceWith('<img src="'+ qcld_ilist_drag_ajax.QCOPD_IMG_URL1+'/loading.svg" >');
          var q = '';
          jQuery.post('.', {
          qcld_ilist_meme_images_upload: "1",
          image_url: image_url,
          image_src_page: image_page_url,
          image_user: photographer,
          q: q,
          wpnonce: qcld_ilist_drag_ajax.meme_images_security_nonce
        },
        function(data){

          var ext = data.split(".");
            ext = ext[ext.length-1].toLowerCase();      
            var arrayExtensions = ["jpg" , "jpeg", "png", "bmp", "gif"];
            if (arrayExtensions.lastIndexOf(ext) == -1) {
            alert(data + ' , Image can not uploaded !');
            currentDom.removeClass("uploading").find('.download img').replaceWith('<img src="'+ qcld_ilist_drag_ajax.QCOPD_IMG_URL1+'/download.svg" >');
          }else{
            $("#qcilist_pro_meme_canvas_img_path").attr('src', data); 
            $("#qcilist_pro_meme_canvas_img_path").show();
            currentDom.removeClass("uploading").find('.download img').replaceWith('<img src="'+ qcld_ilist_drag_ajax.QCOPD_IMG_URL1+'/download.svg" >');
            saveFileData();
          }

      });
      return false;

  });


  $(document).on('keyup', '#qcilist_pro_meme_toplinetext', function(e){
    e.preventDefault();

    result_text = $(this).val();
    $('.qcilist_pro_meme_canvas_line_one').html(result_text);

    saveFileData();

  });

  $(document).on('keyup', '#qcilist_pro_meme_bottomlinetext', function(e){
    e.preventDefault();

    result_text = $(this).val();
    $('.qcilist_pro_meme_canvas_line_two').html(result_text);
    saveFileData();

  });


  $(document).on('keyup', '.qcilist_pro_meme_pixel_image_wrap input[type="text"]', function(e){
    e.preventDefault();

      var content_warppers = $(this);

        content_warppers.closest('.qcilist_pro_meme_pixel_image_wrap').addClass('qcld-loading');

        result_text = $(this).val();

        if (result_text.length < 2) {
          content_warppers.closest('.qcilist_pro_meme_pixel_image_wrap').removeClass('qcld-loading');
          return false;
        }    

        $('#qcilist_pro_meme_pixel_image_show').empty();

        var show_page = 1;
        var show_per_page = 120;
        var pexels_api_key = '563492ad6f91700001000001fa992db66f9949ce87de557793c49455';
        var queryURL = 'https://api.pexels.com/v1/search?query='+result_text+'&page='+show_page+'&per_page='+show_per_page;
        $.ajax({
          url: queryURL,
          headers: {
            "Authorization": pexels_api_key
          },
          method: "GET"
        }).done(function(response) {
          //console.log(response);
          if(response.photos.length<1){
            gifbackground = true;
          }else {
            //Appends gifs to proper #img div
            for (var i = 0; i < response.photos.length; i++) {   

              //console.log(response);
              $('#qcilist_pro_meme_pixel_image_show').append('<div class="qcld-meme-pixel-photo_added"><img numvalue="'+i+'" src="'+response.photos[i].src.small+'" data-img="'+response.photos[i].src.original+'" data-url="'+response.photos[i].url+'" data-photographer="'+response.photos[i].photographer+'">'+
                '<div class="download"><img src="'+qcld_ilist_drag_ajax.QCOPD_IMG_URL1+'/download.svg"><div>'+response.photos[i].width+'×'+response.photos[i].height+'<br><a href="'+response.photos[i].url+'" rel="noopener nofollow" target="_blank" "="">'+response.photos[i].photographer+'</a></div></div></div>');

            }

          }

        });

        setTimeout(function(){ 
          content_warppers.closest('.qcilist_pro_meme_pixel_image_wrap').removeClass('qcld-loading');
        }, 3000);
        return false;

  });


  qcldPixelApiImage_show();

  function qcldPixelApiImage_show(){

    $('#qcilist_pro_meme_pixel_image_show').empty();
    var custom = 'funny';
    var show_page = 1;
    var show_per_page = 120;
    var pexels_api_key = '563492ad6f91700001000001fa992db66f9949ce87de557793c49455';

    var queryURL = 'https://api.pexels.com/v1/search?query='+custom+'&page='+show_page+'&per_page='+show_per_page;
    $.ajax({
      url: queryURL,
      headers: {
        "Authorization": pexels_api_key
      },
      method: "GET",
    }).done(function(response) {
      //console.log(response);
      if(response.photos.length<1){
        gifbackground = true;
      }else {
        //Appends gifs to proper #img div
        for (var i = 0; i < response.photos.length; i++) {  

          $('#qcilist_pro_meme_pixel_image_show').append('<div class="qcld-meme-pixel-photo_added"><img numvalue="'+i+'" src="'+response.photos[i].src.small+'" data-img="'+response.photos[i].src.original+'" data-url="'+response.photos[i].url+'" data-photographer="'+response.photos[i].photographer+'">'+
                  '<div class="download"><img src="'+qcld_ilist_drag_ajax.QCOPD_IMG_URL1+'/download.svg"><div>'+response.photos[i].width+'×'+response.photos[i].height+'<br><a href="'+response.photos[i].url+'" rel="noopener nofollow" target="_blank" "="">'+response.photos[i].photographer+'</a></div></div></div>');
        }

      }

    });

  }

	
});