<?php 

//Simple list assets
function qcilist_pro_check_for_shortcode($posts) {
    if ( empty($posts) )
        return $posts;
 
    // false because we have to search through the posts first
    $found = false;
 
    // search through each post
    foreach ($posts as $post) {
        // check the post content for the short code
        if ( stripos($post->post_content, 'qcld-ilist') )
            // Found a post with the short code
            $found = true;
            // stop the search
            break;
        }

    if ($found){
       //Load Script and Stylesheets
       
    }

    return $posts;
}

//perform the check when the_posts() function is called
add_action('the_posts', 'qcilist_pro_check_for_shortcode');

/*
add_action('wp_enqueue_scripts', 'qcilist_pro_load_all_scripts_chart');
function qcilist_pro_load_all_scripts_chart(){
	wp_register_script( 'ilist-chart-js', QCOPD_ASSETS_URL1 . '/js/Chart.js', array('jquery'));
}
*/

function qcilist_pro_load_all_scripts(){

    global $post;
    if( is_a( $post, 'WP_Post' ) && ( has_shortcode( $post->post_content, 'qcld-ilist') || has_shortcode( $post->post_content, 'qcld-drag-drop-page') ) ) {
        
        wp_enqueue_style( 'ilist-fontawesome-css', QCOPD_ASSETS_URL1 . '/css/font-awesome.min.css');
        wp_enqueue_style( 'ilist-animate-css', QCOPD_ASSETS_URL1 . '/css/animate.css');
        wp_enqueue_style( 'ilist-main-custom-css', QCOPD_ASSETS_URL1 . '/css/sl-directory-style.css');
        wp_enqueue_style( 'ilist-box-custom-css', QCOPD_ASSETS_URL1 . '/css/ilist-box-style.css');
        wp_enqueue_style( 'ilist-main-custom-rwd-css', QCOPD_ASSETS_URL1 . '/css/sl-directory-style-rwd.css');
        wp_enqueue_style('ilist_img5_fancybox_css', QCOPD_ASSETS_URL1."/fancybox/jquery.fancybox.css");
        wp_enqueue_style( 'ilist_img5fd_light_css', QCOPD_ASSETS_URL1."/css/lightbox.min.css");

        //Scripts
        wp_enqueue_script( 'jquery', 'jquery');
        
        wp_enqueue_script( 'ilist-qcopd-grid-packery', QCOPD_ASSETS_URL1 . '/js/packery.pkgd.js', array('jquery'));
        wp_enqueue_script( 'ilist_img5fd_light', QCOPD_ASSETS_URL1 . "/js/lightbox-plus-jquery.min.js", array('jquery'));
        wp_enqueue_script( 'ilist-chart-js', QCOPD_ASSETS_URL1 . '/js/Chart.js', array('jquery'));
        wp_enqueue_script( 'ilist-wow-js', QCOPD_ASSETS_URL1 . '/js/wow.min.js', array('jquery'));

        wp_enqueue_script( 'ilist_img5_fancybox', QCOPD_ASSETS_URL1 . "/fancybox/jquery.fancybox.pack.js", array('jquery'));
        wp_enqueue_script( 'ilist-canvas-cap-field-js', QCOPD_ASSETS_URL1 . '/js/qcld-html2canvas.min.js', array( 'jquery' ) );
        
        wp_enqueue_script( 'ilist-qcopd-custom-script', QCOPD_ASSETS_URL1 . '/js/directory-script.js', array('jquery', 'ilist-qcopd-grid-packery'));

        $qcld_ajax = array(
                'admin_url'       => admin_url( 'admin-ajax.php', is_ssl() ? 'https' : 'http' ),
                'qcld_ajax_nonce' => wp_create_nonce( 'qcld-ilist' ),
                );

        wp_localize_script( 'ilist-qcopd-custom-script', 'qcld_ilist_ajax', $qcld_ajax );

    }
    
   
}
add_action('wp_enqueue_scripts', 'qcilist_pro_load_all_scripts');

function qcilist_pro_admin_style_script_all(){
    global $post_type;
    wp_enqueue_style( 'admin-fontawesome-css', QCOPD_ASSETS_URL1 . '/css/font-awesome.css');
    wp_enqueue_style( 'ilist_admin_light_css', QCOPD_ASSETS_URL1 . "/css/lightbox.min.css");
    wp_enqueue_style( 'ilist-fa-field-csss', QCOPD_ASSETS_URL1 . '/css/fa-field.css' );
    wp_enqueue_style( 'ilist-chart-field-css', QCOPD_ASSETS_URL1 . '/css/chart-field.css' );
    wp_enqueue_style( 'ilist_img5_fancyboxes_css', QCOPD_ASSETS_URL1 . "/fancybox/jquery.fancybox.css");
    wp_enqueue_style( 'ilist-admin-animate-css', QCOPD_ASSETS_URL1 . '/css/animate.css');
	wp_enqueue_style( 'ilist-admin-css', QCOPD_ASSETS_URL1 . '/css/ilist_custom_style.css');
    wp_enqueue_style( 'ilist_custom-rwd-embed', QCOPD_URL1 . '/embed/css/embed-form.css');


    
    //wp_enqueue_script( 'jquery', 'jquery');
  
    wp_enqueue_script( 'ilist_admin_light', QCOPD_ASSETS_URL1 . "/js/lightbox-plus-jquery.min.js", array('jquery'));
    wp_enqueue_script( 'ilist_img5_fancybox_js', QCOPD_ASSETS_URL1 . "/fancybox/jquery.fancybox.pack.js", array('jquery'));
    wp_enqueue_script( 'ilist-admin-wow-js', QCOPD_ASSETS_URL1 . '/js/wow.min.js', array('jquery'));
	
	if( $post_type == 'ilist' || $post_type == 'qc_ilist_drag_drop' ){

        wp_enqueue_script( 'ilist-canvas-field-js', QCOPD_ASSETS_URL1 . '/js/qcld-html2canvas.min.js', array( 'jquery' ) );
        // load up plugin js
        wp_enqueue_style( 'wp-color-picker' );
        wp_enqueue_script( 'wp-color-picker');



        wp_enqueue_script( 'ilist-admin-quicksearch-js', QCOPD_ASSETS_URL1 . '/js/jquery.quicksearch.js', array('jquery') );
        wp_enqueue_script( 'ilist-admin-lazyload-js', QCOPD_ASSETS_URL1 . '/js/lazyload.js', array('jquery') );
        wp_enqueue_script( 'ilist-fa-field-js', QCOPD_ASSETS_URL1 . '/js/fa-field.js', array( 'jquery' ) );
        wp_enqueue_script( 'ilist-chart-field-js', QCOPD_ASSETS_URL1 . '/js/chart-field.js', array( 'jquery' ) );
        wp_deregister_script('quform-insert-form');

    }        

    if( isset($_GET['page']) && $_GET['page'] == 'analytify-dashboard' ){

        wp_deregister_script('custom-script-handle');

    }

    wp_enqueue_script( 'ilist-admin-script', QCOPD_ASSETS_URL1 . '/js/ilist_custom_admin.js', array('jquery'));

    $qcld_ajax = array(
            'admin_url'       => admin_url( 'admin-ajax.php', is_ssl() ? 'https' : 'http' ),
            'qcld_ajax_nonce' => wp_create_nonce( 'qcld-ilist' ),
            );

    wp_localize_script( 'ilist-admin-script', 'qcld_ilist_ajax', $qcld_ajax );
	
}
add_action( 'admin_enqueue_scripts', 'qcilist_pro_admin_style_script_all', 100 );



?>