<?php 

defined('ABSPATH') or die("No direct script access!");

/**
 * Add the link to action list for post_row_actions
 */

add_action('admin_init','qc_ilist_duplicate_post_admin_inits');
if(!function_exists('qc_ilist_duplicate_post_admin_inits')){
	function qc_ilist_duplicate_post_admin_inits(){

		add_filter('post_row_actions', 'qc_ilist_duplicate_post_make_duplicate_link_row',10,2);
		add_filter('page_row_actions', 'qc_ilist_duplicate_post_make_duplicate_link_row',10,2);

		add_filter('removable_query_args', 'qc_ilist_duplicate_post_add_removable_query_arg', 10, 1);
		
		add_action('qc_ilist_dp_duplicate_post', 'qc_ilist_duplicate_post_copy_post_meta_info', 10, 2);
		add_action('qc_ilist_dp_duplicate_post', 'qc_ilist_duplicate_post_copy_post_meta_info', 10, 2);

	}
}

if(!function_exists('qc_ilist_duplicate_post_make_duplicate_link_row')){
	function qc_ilist_duplicate_post_make_duplicate_link_row($actions, $post) {
		if ( qc_ilist_duplicate_post_is_post_type_enabled($post->post_type)) {
			$title = _draft_or_post_title( $post );
			$actions['qc_clone'] = '<a href="'.qc_ilist_duplicate_post_get_clone_post_link( $post->ID , 'display', false).'" aria-label="'
					. esc_attr( sprintf( __('Clone &#8220;%s&#8221;', 'qc-opd'), $title ) )
					. '">' .  esc_html__('Clone List', 'qc-opd') . '</a>';
		}
		return $actions;
	}
}


if(!function_exists('qc_ilist_duplicate_post_is_post_type_enabled')){
	function qc_ilist_duplicate_post_is_post_type_enabled($post_type){

		$duplicate_post_types_enabled = array('ilist','ilist-meme', 'qc_ilist_drag_drop');
		return in_array($post_type, $duplicate_post_types_enabled);
	}
}

if(!function_exists('qc_ilist_duplicate_post_get_clone_post_link')){
	function qc_ilist_duplicate_post_get_clone_post_link( $id = 0, $context = 'display', $draft = true ) {

		if ( !$post = get_post( $id ) )
			return;
		
		if(!qc_ilist_duplicate_post_is_post_type_enabled($post->post_type))
			return;

		if ($draft)
		$action_name = "qc_ilist_duplicate_post_save_as_new_post_draft";
		else
		$action_name = "qc_ilist_duplicate_post_save_as_new_post";

		if ( 'display' == $context )
		$action = '?action='.$action_name.'&amp;post='.$post->ID;
		else
		$action = '?action='.$action_name.'&post='.$post->ID;

		$post_type_object = get_post_type_object( $post->post_type );
		if ( !$post_type_object )
		return;

		return wp_nonce_url(apply_filters( 'qc_ilist_duplicate_post_get_clone_post_link', admin_url( "admin.php". $action ), $post->ID, $context ), 'qc_ilist_duplicate-post_' . $post->ID);
		//return admin_url( "admin.php". $action );
	}
}



/*
 * This function calls the creation of a new copy of the selected post (as a draft)
* then redirects to the edit post screen
*/
if(!function_exists('qc_ilist_duplicate_post_save_as_new_post_draft')){
function qc_ilist_duplicate_post_save_as_new_post_draft(){
	qc_ilist_duplicate_post_save_as_new_post('draft');
}
}

if(!function_exists('qc_ilist_duplicate_post_add_removable_query_arg')){
function qc_ilist_duplicate_post_add_removable_query_arg( $removable_query_args ){
	$removable_query_args[] = 'cloned';
	return $removable_query_args;
}
}

/*
 * preserving the original publish status)
 */
add_action('admin_init','qc_ilist_duplicate_post_save_as_new_post');

if(!function_exists('qc_ilist_duplicate_post_save_as_new_post')){
function qc_ilist_duplicate_post_save_as_new_post($status = ''){
	
	if (( ( isset( $_GET['post']) || isset( $_POST['post']))  && ( isset($_REQUEST['action']) && 'qc_ilist_duplicate_post_save_as_new_post' == $_REQUEST['action'] ) ) ) {

	// Get the original post
	$id = (isset($_GET['post']) ? $_GET['post'] : $_POST['post']);

	check_admin_referer('qc_ilist_duplicate-post_' . $id);
	
	$post = get_post($id);	

	// Copy the post and insert it
	if (isset($post) && $post!=null) {
		$post_type = $post->post_type;
		$new_id = qc_ilist_duplicate_post_create_duplicate($post, $status);
		qc_ilist_duplicate_post_copy_post_meta_info($post, $status);
		
		if ($status == ''){
			$sendback = wp_get_referer();
			if ( ! $sendback ||
					strpos( $sendback, 'post.php' ) !== false ||
					strpos( $sendback, 'post-new.php' ) !== false ) {
						if ( 'attachment' == $post_type ) {
							$sendback = admin_url( 'upload.php' );
						} else {
							$sendback = admin_url( 'edit.php' );
							if ( ! empty( $post_type ) ) {
								$sendback = add_query_arg( 'post_type', $post_type, $sendback );
							}
						}
					} else {
						$sendback = remove_query_arg( array('trashed', 'untrashed', 'deleted', 'cloned', 'ids'), $sendback );
					}
			// Redirect to the post list screen
			wp_redirect( add_query_arg( array( 'cloned' => 1, 'ids' => $post->ID), $sendback ) );
		} else {
			// Redirect to the edit screen for the new draft post
			wp_redirect( add_query_arg( array( 'cloned' => 1, 'ids' => $post->ID), admin_url( 'post.php?action=edit&post=' . $new_id ) ) );
		}
		exit;

	} 

	}


}
}


/**
 * Create a duplicate from a post
 */
if(!function_exists('qc_ilist_duplicate_post_create_duplicate')){
function qc_ilist_duplicate_post_create_duplicate($post, $status = '', $parent_id = '') {
	
	do_action('qc_ilist_duplicate_post_pre_copy');

	if (!qc_ilist_duplicate_post_is_post_type_enabled($post->post_type) && $post->post_type != 'attachment')
		wp_die(esc_html__('Copy features for this post type are not enabled in options page', 'duplicate-post'));
		
	$new_post_status = (empty($status))? $post->post_status: $status;
	
	if ($post->post_type != 'attachment'){
		
		$title = trim($post->post_title);

		if ($title == ''){
			// empty title
			$title = __('Untitled', 'default');
		}

		if(isset($post->post_type) && ('ilist' === $post->post_type)){

			$new_post_status = 'draft';

		}

		if ( 'publish' == $new_post_status || 'future' == $new_post_status ){
			// check if the user has the right capability
			if(is_post_type_hierarchical( $post->post_type )){
				if(!current_user_can('publish_pages')){
					$new_post_status = 'pending';
				}
			} else {
				if(!current_user_can('publish_posts')){
					$new_post_status = 'pending';
				}
			}
		}
		
	}	
	
	$new_post_author = wp_get_current_user();
	$new_post_author_id = $new_post_author->ID;
	
	$menu_order = $post->menu_order ? $post->menu_order : 0;
	
	$post_name = $post->post_name;
	
	$new_post = array(
	'menu_order' => $menu_order,
	'comment_status' => $post->comment_status,
	'ping_status' => $post->ping_status,
	'post_author' => $new_post_author_id,
	'post_content' => $post->post_content ? $post->post_content : "" ,
	'post_content_filtered' => $post->post_content_filtered ? $post->post_content_filtered : "" ,			
	'post_excerpt' => $post->post_excerpt ? $post->post_excerpt : "",
	'post_mime_type' => $post->post_mime_type,
	'post_parent' => $new_post_parent = empty($parent_id)? $post->post_parent : $parent_id,
	'post_password' => $post->post_password ? $post->post_password: "",
	'post_status' => $new_post_status,
	'post_title' => $title,
	'post_type' => $post->post_type,
	'post_name' => $post_name
	);

	$new_post_id = wp_insert_post(wp_slash($new_post));

	// If you have written a plugin which uses non-WP database tables to save
	// information about a post you can hook this action to dupe that data.
	
	if($new_post_id !== 0 && !is_wp_error($new_post_id)){
		
		if ($post->post_type == 'page' || is_post_type_hierarchical( $post->post_type ))
			do_action( 'qc_ilist_dp_duplicate_post', $new_post_id, $post, $status );
		else
			do_action( 'qc_ilist_dp_duplicate_post', $new_post_id, $post, $status );
	
		delete_post_meta($new_post_id, 'qc_ilist_dp_original');
		add_post_meta($new_post_id, 'qc_ilist_dp_original', $post->ID);
	
		do_action('qc_ilist_duplicate_post_post_copy');
		
	}
	
	return $new_post_id;
}
}


/**
 * Copy the meta information of a post to another post
*/
if(!function_exists('qc_ilist_duplicate_post_copy_post_meta_info')){
function qc_ilist_duplicate_post_copy_post_meta_info($new_id, $post) {

	if(!qc_ilist_duplicate_post_is_post_type_enabled($post->post_type))
		return;

	$post_meta_keys = get_post_custom_keys($post->ID);
	if (empty($post_meta_keys)) return;
	$meta_blacklist = get_option('duplicate_post_blacklist');
	if ($meta_blacklist == ""){
		$meta_blacklist = array();
	} else {
		$meta_blacklist = explode(',', $meta_blacklist);
		$meta_blacklist = array_filter($meta_blacklist);
		$meta_blacklist = array_map('trim', $meta_blacklist);
	}	
	$meta_blacklist[] = '_edit_lock'; // edit lock
	$meta_blacklist[] = '_edit_last'; // edit lock
	
	
	$meta_blacklist = apply_filters( 'qc_ilist_duplicate_post_blacklist_filter' , $meta_blacklist );
	
	$meta_blacklist_string = '('.implode(')|(',$meta_blacklist).')';
	if(strpos($meta_blacklist_string, '*') !== false){
		$meta_blacklist_string = str_replace(array('*'), array('[a-zA-Z0-9_]*'), $meta_blacklist_string);
	
		$meta_keys = array();
		foreach($post_meta_keys as $meta_key){
			if(!preg_match('#^'.$meta_blacklist_string.'$#', $meta_key))
				$meta_keys[] = $meta_key;
		}
	} else {
		$meta_keys = array_diff($post_meta_keys, $meta_blacklist);
	}

	$meta_keys = apply_filters( 'qc_ilist_duplicate_post_blacklist_filter', $meta_keys );

	foreach ($meta_keys as $meta_key) {
		$meta_values = get_post_custom_values($meta_key, $post->ID);
		foreach ($meta_values as $meta_value) {
			$meta_value = maybe_unserialize($meta_value);
			add_post_meta($new_id, $meta_key, $meta_value);
		}
	}

}
}

add_action( 'admin_init', 'qc_ilist_duplicate_post_jetpack_init' );

if(!function_exists('qc_ilist_duplicate_post_jetpack_init')){
function qc_ilist_duplicate_post_jetpack_init() {

	add_filter('qc_ilist_duplicate_post_blacklist_filter', 'qc_ilist_duplicate_post_jetpack_add_to_blacklist', 10, 1 );
	
	if (class_exists('WPCom_Markdown')){
		add_action('qc_ilist_duplicate_post_pre_copy', 'qc_ilist_duplicate_post_jetpack_disable_markdown', 10);
		add_action('qc_ilist_duplicate_post_post_copy', 'qc_ilist_duplicate_post_jetpack_enable_markdown', 10);
	}	
}
}

if(!function_exists('qc_ilist_duplicate_post_jetpack_add_to_blacklist')){
function qc_ilist_duplicate_post_jetpack_add_to_blacklist($meta_blacklist) {
	$meta_blacklist[] = '_wpas*'; //Jetpack Publicize
	$meta_blacklist[] = '_publicize*'; //Jetpack Publicize
	
	$meta_blacklist[] = '_jetpack*'; //Jetpack Subscriptions etc.
	
	return $meta_blacklist;
}
}

// Markdown
if(!function_exists('qc_ilist_duplicate_post_jetpack_disable_markdown')){
function qc_ilist_duplicate_post_jetpack_disable_markdown(){
	WPCom_Markdown::get_instance()->unload_markdown_for_posts();
}
}

if(!function_exists('qc_ilist_duplicate_post_jetpack_enable_markdown')){
function qc_ilist_duplicate_post_jetpack_enable_markdown(){
	WPCom_Markdown::get_instance()->load_markdown_for_posts();
}
}