<?php 
/**
 * Plugin Name: iList - Pro
 * Plugin URI: https://www.quantumcloud.com/iList/
 * Description: iList - Pro is first of its kind WordPress plugin to build and create Infographics and elegant Lists effortlessly.
 * Version: 8.1.4
 * Author: QuantumCloud
 * Author URI: https://www.quantumcloud.com/
 * Requires at least: 4.6
 * Tested up to: 6.2
 * Text Domain: qc-opd
 * Domain Path: /lang/
 * License: GPL2
 */
 
 defined('ABSPATH') or die("No direct script access!");
 
 global $qc_ilist_version;
 $qc_ilist_version = '1.1.0';
 
//Custom Constants
if ( ! defined( 'QCOPD_URL1' ) ) {
	define('QCOPD_URL1', plugin_dir_url(__FILE__));
}
if ( ! defined( 'QCOPD_IMG_URL1' ) ) {
	define('QCOPD_IMG_URL1', QCOPD_URL1 . "/assets/images");
}
if ( ! defined( 'QCOPD_ASSETS_URL1' ) ) {
	define('QCOPD_ASSETS_URL1', QCOPD_URL1 . "/assets");
}
if ( ! defined( 'QCOPD_DIR1' ) ) {
	define('QCOPD_DIR1', dirname(__FILE__));
}
if ( ! defined( 'QCOPD_INC_DIR1' ) ) {
	define('QCOPD_INC_DIR1', QCOPD_DIR1 . "/inc");
}
if ( ! defined( 'OCOPD_TPL_DIR1' ) ) {
	define('OCOPD_TPL_DIR1', QCOPD_DIR1 . "/views");
}
if ( ! defined( 'OCOPD_TPL_URL1' ) ) {
	define('OCOPD_TPL_URL1', QCOPD_URL1 . "/views");
}


require_once( 'qc-project-ilist-framework.php' );
require_once( 'qc-project-ilist-post-type.php' );
require_once( 'qc-project-ilist-post-type-meme.php' );
require_once( 'qc-project-ilist-chart.php' );
require_once( 'qc-project-ilist-asset.php' );
require_once( 'qc-project-ilist-ajax.php' );
require_once( 'qc-project-ilist-shortcode.php' );
require_once( 'qc-project-ilist-shortcode-compare.php' );
require_once( 'qc-project-ilist-hook.php' );
require_once( 'qc-project-ilist-shorting.php' );
require_once( 'qc-project-ilist-fa.php' );
require_once( 'qc-project-ilist-drag-drop-function.php' );
require_once( 'qc-project-ilist-drag-drop-shortcode.php' );
require_once( 'qc-project-ilist-duplicate-post.php' );

add_filter( 'ot_theme_mode', '__return_false', 999 );
require_once( 'option-tree/ot-loader.php' );

require('plugin-upgrader/plugin-upgrader.php');

require_once( 'qc-support-promo-page/class-qc-support-promo-page.php' );
load_plugin_textdomain( 'qc-ilist', false, dirname( plugin_basename( __FILE__ ) ) . '/lang' );
function ilist_load_admin_links()
{
	global $pagenow, $typenow;
	if (is_admin() && $pagenow=='post-new.php' && $typenow=='ilist'){
	
	wp_enqueue_style('google-font-api1',"https://fonts.googleapis.com/css?family=Aref+Ruqaa|Droid+Sans|Droid+Serif|Lora|Nova+Script|Open+Sans|PT+Sans+Narrow|Playfair+Display|Roboto|Ubuntu|Bitter|Exo|Montserrat|Raleway|Sonsie+One");
	
	}
   
}
add_action('admin_init','ilist_load_admin_links');

function ilist_posttype_admin_css() {
    global $post_type;
    $post_types = array(
                        /* set post types */
                        'ilist',

                  );
    if(in_array($post_type, $post_types))
    echo '<style type="text/css">#post-preview, #view-post-btn{display: none;}</style>';
}
add_action( 'admin_head-post-new.php', 'ilist_posttype_admin_css' );
add_action( 'admin_head-post.php', 'ilist_posttype_admin_css' );

if(!function_exists('ilist_progress_bar')){
	function ilist_progress_bar($value,$class=''){
		if($value>0):
	?>
	<div style="clear:both"></div>
	<div class="ilist-progress-bar-container <?php echo $class; ?>"> 
		<p style="width:<?php echo $value; ?>%" data-value="<?php echo $value; ?>"></p>
		<progress max="100" value="<?php echo $value; ?>" class="ilist-progress-style">
			<div class="ilist-progress-bar">
				<span style="width: <?php echo $value; ?>%"><?php echo $value; ?>%</span>
			</div>
		</progress>
	</div>
	<?php
		endif;
	}
}
if(!function_exists('ilist_progress_bar_')){
	function ilist_progress_bar_($value){
		if($value>0):
		ob_start();
	?>
	
	<div class="ilist-progress-bar-container"> 
		<p style="width:<?php echo $value; ?>%" data-value="<?php echo $value; ?>"></p>
		<progress max="100" value="<?php echo $value; ?>" class="ilist-progress-style">
			<div class="ilist-progress-bar">
				<span style="width: <?php echo $value; ?>%"><?php echo $value; ?>%</span>
			</div>
		</progress>
	</div>
	<?php
		$content = ob_get_clean();
		return $content;
		endif;
	}
}

add_action( 'admin_menu' , 'qcilist_pro_help_link_submenu', 20 );
function qcilist_pro_help_link_submenu(){
	global $submenu;

	add_submenu_page( 'edit.php?post_type=ilist', 'Help & License', 'Help & License', 'manage_options', 'qc-ilist-sessions-help-license', 'qcilist_pro_sessions_license_callback' );

	ksort($submenu["edit.php?post_type=ilist"]);
	
	return ($submenu);
}


add_action( 'add_meta_boxes', 'qcilist_pro_meta_box_video' );
function qcilist_pro_meta_box_video(){

    add_meta_box( 
			'qc-ilist-meta-box-id', // ID attribute of metabox
			'Shortcode Generator for iList',       // Title of metabox visible to user
			'qcilist_pro_meta_box_callback', // Function that prints box in wp-admin
			'page',              // Show box for posts, pages, custom, etc.
			'side',            // Where on the page to show the box
			'high' 
		); 
}

function qcilist_pro_meta_box_callback( $post ){

    ?>
    <p>
        <label for="sh_meta_box_bg_effect"><p><?php esc_html_e('Click the button below to generate shortcode'); ?></p></label>
		<input type="button" id="ilist_shortcode_generator_meta" class="button button-primary button-large" value="<?php esc_attr_e('Generate Shortcode'); ?>" />
    </p>
    
    <?php
}

//add_action( 'add_meta_boxes', 'qcilist_pro_ichart_meta_box_video' );
function qcilist_pro_ichart_meta_box_video(){	
				                  // --- Parameters: ---
    add_meta_box( 'qc-ichart-meta-box-id', // ID attribute of metabox
                  'Shortcode Generator for iChart',       // Title of metabox visible to user
                  'qcilist_pro_ichart_meta_box_callback', // Function that prints box in wp-admin
                  'page',              // Show box for posts, pages, custom, etc.
                  'side',            // Where on the page to show the box
                  'high' );            // Priority of box in display order
}

function qcilist_pro_ichart_meta_box_callback( $post ){
    ?>
    <p>
        <label for="sh_meta_box_bg_effect"><p><?php esc_html_e('Click the button below to generate shortcode'); ?></p></label>
		<input type="button" id="ichart_shortcode_generator_meta" class="button button-primary button-large" value="<?php esc_attr_e('Generate Shortcode'); ?>" />
    </p>
    
    <?php
}

add_action( 'activated_plugin', 'qc_ilistpro_activation_redirect' );
function qc_ilistpro_activation_redirect( $plugin ) {

    /**
     * Free version replace code.
     */
    $free = array( 'infographic-and-list-builder-ilist/qc-project-ilist-main.php' );
    $all_plugins = get_plugins();
    foreach( $all_plugins as $plugin => $plugin_details ){
        if( in_array( $plugin, $free ) ){
            if( is_plugin_active( $plugin ) ){
                if( deactivate_plugins( array( $plugin ) ) ){
                    delete_plugins( array( $plugin ) );
                }
            } else {
                delete_plugins( array( $plugin ) );
            }
        }
    }
    /**
     * Free version replace code End.
     */

	if( $plugin == plugin_basename( __FILE__ ) ) {
		exit( wp_redirect( admin_url( 'edit.php?post_type=ilist&page=qc-ilist-sessions-help-license') ) );
	}
}

if( function_exists('register_block_type') ){
	function qcilist_pro_gutenberg_block() {
	    require_once plugin_dir_path( __FILE__ ).'/gutenberg/ilist-block/plugin.php';
	}
	add_action( 'init', 'qcilist_pro_gutenberg_block' );
}

function qcilist_pro_sessions_license_callback(){
	?>
	<div class="qcld-ilist-section-block">
		<div id="licensing">
			<h1><?php esc_html_e('Please Insert your license Key'); ?></h1>

			<?php
                    $total_active_domain = 0;
                    $active_domain_lists = array();
                    $track_domain_request = wp_remote_get(ilistpro_LICENSING_PRODUCT_DEV_URL."wp-json/qc-domain-tracker/v1/getdomain/?license_key=".get_ilistpro_licensing_key(), array('timeout' => 300));
                    if( !is_wp_error( $track_domain_request ) || wp_remote_retrieve_response_code( $track_domain_request ) === 200 ){
                        $track_domain_result = json_decode($track_domain_request['body']);
                        
                        $current_domain_url =  site_url() ;
                        $current_domain = str_replace(
                                                array( 'https://', 'http://', 'www.' ),
                                                array('', '', ''),
                                                $current_domain_url
                                            );
                        if( !empty($track_domain_result) ){
                            $max_domain_num = $track_domain_result[0]->max_domain + 1;
                            $total_domains = json_decode($track_domain_result[0]->domain, true);
                            $total_domains_num = count($total_domains);

                            foreach ($total_domains as $key => $value) {
                                if( !isset($value['status']) || $value['status'] == 'active' ){
                                    $total_active_domain++;
                                    $active_domain_lists[] = $value['domain_name'];
                                }
                            }

                            if($total_active_domain == $max_domain_num){
                            //if( $max_domain_num < $total_active_domain ){
                                //$first_domain_name = $total_domains[0]['domain_name'];
                                if( !in_array($current_domain, $active_domain_lists) ){
                                    set_ilistpro_invalid_license();
                                    delete_ilistpro_valid_license();
                        ?>
                                    <div class="qcld-error-notice">
                                        <p><?php esc_html_e('You have activated this key for maximum number of sites allowed by your license. Please'); ?> <a href='https://www.quantumcloud.com/products/'><?php esc_html_e('purchase additional license.'); ?></a></p>
                                    </div>
                        <?php
                                }
                            }
                        }
                        
                    }
                ?>

			<?php if( get_ilistpro_valid_license() ){ ?>
				<div class="qcld-success-notice">
					<p> <?php esc_html_e('Thank you, Your License is active.'); ?> <?php if( get_ilistpro_licensing_buy_from() == 'codecanyon' ){ ?> <?php esc_html_e('Please'); ?> <a href="https://envato.com/market-plugin/"><?php esc_html_e('Download'); ?> </a> <?php esc_html_e('the Envato Market Plugin to Get Auto Updates During Your Support Period.'); ?> <?php } ?></p>
				</div>
			<?php } ?>
			
			<form onsubmit="return false" id="qc-license-form" method="post" action="options.php">
				<?php
					delete_ilistpro_update_transient();
					delete_ilistpro_renew_transient();
					
					delete_option('_site_transient_update_plugins');
					settings_fields( 'qcld_ilistpro_license' );
					do_settings_sections( 'qcld_ilistpro_license' );

					// if( isset($_POST['submit']) ){
					// 	echo 'qcld_ilistpro_buy_from_where '.$_POST['qcld_ilistpro_buy_from_where'];
					// }
				?>
				<table class="form-table">
					

					<tr id="quantumcloud_portfolio_license_row" style="display: none">
						<th>
							<label for="qcld_ilistpro_enter_license_key"><?php esc_html_e('Enter License Key:'); ?></label>
						</th>
						<td>
							<input type="<?php echo (get_ilistpro_licensing_key()!=''?'password':'text'); ?>" id="qcld_ilistpro_enter_license_key" name="qcld_ilistpro_enter_license_key" class="regular-text" value="<?php echo get_ilistpro_licensing_key(); ?>">
							<p><?php esc_html_e('You can copy the license key from'); ?> <a target="_blank" href='https://www.quantumcloud.com/products/account/'><?php esc_html_e('your account'); ?></a></p>
						</td>
					</tr>

					<tr id="show_envato_plugin_downloader" style="display: none">
						<th>
							<label for="qcld_ilistpro_enter_envato_key"><?php esc_html_e('Enter Purchase Code:'); ?></label>
						</th>
						<td colspan="4">
							<input type="<?php echo (get_ilistpro_envato_key()!=''?'password':'text'); ?>" id="qcld_ilistpro_enter_envato_key" name="qcld_ilistpro_enter_envato_key" class="regular-text" value="<?php echo get_ilistpro_envato_key(); ?>">
							<p><?php esc_html_e('You can install the'); ?> <a target="_blank" href="https://envato.com/market-plugin/"><?php esc_html_e('Envato Plugin'); ?></a> <?php esc_html_e('to stay up to date.'); ?></p>
						</td>
					</tr>
					
					<tr>
						<th>
							<label for="qcld_ilistpro_enter_license_or_purchase_key"><?php esc_html_e('Enter License Key or Purchase Code:'); ?></label>
						</th>
						<td>
							<input type="<?php echo (get_ilistpro_license_purchase_code()!=''?'password':'text'); ?>" id="qcld_ilistpro_enter_license_or_purchase_key" name="qcld_ilistpro_enter_license_or_purchase_key" class="regular-text" value="<?php echo get_ilistpro_license_purchase_code(); ?>" required>
						</td>
					</tr>

				</table>
				<!-- //start new-update-for-codecanyon -->
				<input type="hidden" name="qcld_ilistpro_buy_from_where" value="<?php echo get_ilistpro_licensing_buy_from(); ?>" >
				<!-- //end new-update-for-codecanyon -->
				<?php submit_button(); ?>
			</form>

			<?php 


					$ilist_license_custom_js = "
							jQuery(document).ready(function(){

								//start new-update-for-codecanyon
								jQuery('#qcld_ilistpro_enter_license_or_purchase_key').on('focusout', function(){
									qc_ilistpro_set_plugin_license_fields();
								});

								jQuery('#qcld_ilistpro_enter_license_or_purchase_key').on('keypress',function (e) {
									  qc_ilistpro_set_plugin_license_fields();
								});

								jQuery('#qc-license-form input[type=submit]').on('click', function(){
									qc_ilistpro_set_plugin_license_fields();
									jQuery('#qc-license-form').removeAttr('onsubmit').submit();
								});

								function qc_ilistpro_set_plugin_license_fields(){
									var license_input = jQuery('#qcld_ilistpro_enter_license_or_purchase_key').val();
									if( /^(\w{8})-((\w{4})-){3}(\w{12})$/.test(license_input) ){
										jQuery('input[name=qcld_ilistpro_buy_from_where]').val('codecanyon');
										jQuery('input[name=qcld_ilistpro_enter_envato_key]').val(license_input);
									}else{
										jQuery('input[name=qcld_ilistpro_buy_from_where]').val('quantumcloud');
										jQuery('input[name=qcld_ilistpro_enter_license_key]').val(license_input);
									}
								}
								//end new-update-for-codecanyon

							});";


					wp_add_inline_script( 'qcld_ilistpro_licensing_script', $ilist_license_custom_js);

			?>
		</div>
	</div>
	<div id="help_section">
	
		<div>
							
			<h1><?php esc_html_e('Welcome to the Infographic Maker - iList! You are'); ?> <strong><?php esc_html_e('awesome'); ?></strong>, <?php esc_html_e('by the way'); ?> <img draggable="false" class="emoji" alt="ðŸ™‚" src="<?php echo QCOPD_IMG_URL1; ?>/1f642.svg"></h1>
			<div class="qcld-ilist-section-block">
			<h3><?php esc_html_e('Getting Started'); ?></h3>
											
			<p><?php esc_html_e('In principle, an infographic is a List created with three building blocks Texts, Images and Charts laid out in a visually impressive manner to convey a specific idea that anyone can easily grasp. iList lets you make Lists with Images, Texts, and Charts (pro feature).'); ?> </p>

			<p><?php esc_html_e('With that in mind you should start with the following simple steps.'); ?></p>
			
			<p><b><?php esc_html_e('Step 1: Go to our Infographic Maker iList and Press on that New iList button.'); ?> </b></p>
			
			<p><b><?php esc_html_e('Step 2: Begin by giving your infographic a Title. Preferably a catchy one to grab users interest. In the next row, we have three options  Info Lists, Graphic Lists, and Infographics. Infographics is selected by default so nothing needs to be done there.'); ?></b></p>
			
			<p><b> <?php esc_html_e('Step 3: Next, you can select a template for your InfoGraphic from a lightbox window which shows a preview of all the available templates. Click on the template you want to start with. Don\'t worry. You can change it later. Anytime!.'); ?></b></p>
			
			<p><b><?php esc_html_e('Step 4: Now comes the fun part. You can now start adding your bullet points for the Lists. Each bullet point or list items can have a Title Text, Description Text, and Image (or Icon).'); ?></b></p>
			
			<p><b><?php esc_html_e('Step 5: The final step is to publish your infographic on a page or post. This is done with a shortcode and the easiest way is to use the Shortcode Generator. After you generated the ShortCode, simply paste it exactly where you want the Infographic to show up.'); ?></b></p>
			
			<p style="color:red"><b><?php esc_html_e('NB:'); ?></b> <?php esc_html_e('iLists must be published before you add the shortcode to a page. iLists won\'t display if it is in Draft mode.'); ?></p>
			
			
			<p><?php esc_html_e('That\'s it! The above steps are for the basic usages. There are a lot of advanced options and tons more templates available with the'); ?> <a href="https://www.quantumcloud.com/products/infographic-maker-ilist/" target="_blank"> <?php esc_html_e('Professional version</a> if you ever feel the need. If you had any specific questions about how something works, do not hesitate to contact us from the'); ?> <a href="<?php echo get_site_url().'/wp-admin/edit.php?post_type=ilist&page=qcpro-promo-page-ilist-free-page-123za'; ?>"><?php esc_html_e('Support Page'); ?></a>. <img draggable="false" class="emoji" alt="ðŸ™‚" src="<?php echo QCOPD_IMG_URL1; ?>/1f642.svg"></p>
											
			<p><strong><a href="https://www.quantumcloud.com/resources/make-infographics-ilist/" target="_blank"><?php esc_html_e('Check'); ?></a> <?php esc_html_e('This Article we Created for the Pro Version for More Details with Images and Screenshots'); ?></strong></p>
			</div>
			<div class="qcld-ilist-section-block">
			<h3><?php esc_html_e('Shortcode Generator'); ?></h3>
			
		<p><?php esc_html_e('We encourage you to use the ShortCode generator found in the toolbar of your page/post editor in visual mode.'); ?></p> 
		
		<img src="<?php echo QCOPD_IMG_URL1; ?>/classic.jpg" alt="shortcode generator" />
		
		<p><?php esc_html_e('See sample below for where to find it for Gutenberg.'); ?></p>

		<img src="<?php echo QCOPD_IMG_URL1; ?>/gutenburg.jpg" alt="shortcode generator" />						
		<img src="<?php echo QCOPD_IMG_URL1; ?>/gutenburg2.jpg" alt="shortcode generator" />	
		<p><?php esc_html_e('This is how the shortcode generator will look like.'); ?></p>				
		<img src="<?php echo QCOPD_IMG_URL1; ?>/shortcode-generator1.jpg" alt="shortcode generator" />								
			
			</div>
			<div class="qcld-ilist-section-block">
			<h3><?php esc_html_e('Shortcode Example'); ?></h3>
			<p>[qcld-ilist mode="one" list_id="75"]
				<br>
				<br>
				<strong><u><?php esc_html_e('Available Parameters:'); ?></u></strong>
				<br>
			</p>
			<p>
				<strong><?php esc_html_e('1. mode'); ?></strong>
				<br>
				<?php esc_html_e('Value for this option can be set as "one" or "all". Example: mode="one"'); ?>
			</p>
			<p>
				<strong><?php esc_html_e('2. column'); ?></strong>
				<br>
				<?php esc_html_e('Avaialble values: "1", "2", "3". Example: column=1'); ?>
			</p>

			<p>
				<strong><?php esc_html_e('6. list_id'); ?></strong>
				<br>
				<?php esc_html_e('Only applicable if you want to display a single list [not all]. You can provide specific list id here as a value. You can also get ready shortcode for a single list under "Manage List Items" menu. Example: list_id="404"'); ?>
			</p>
			
			<p>
				<strong><?php esc_html_e('9. upvote'); ?></strong>
				<br>
				
				<?php esc_html_e('Values: on or off. This options allows upvoting of your list items.'); ?>
				<br>
				<?php esc_html_e('Example: upvote="on"'); ?>
			</p>
			</div>
			<div class="qcld-ilist-section-block">
			<h3><?php esc_html_e('iList Template Overriding'); ?></h3>
			<p><?php esc_html_e('iList does support template overriding from both child theme & parent theme. Child theme will get the first priority.'); ?></p>

			<p><strong>1.</strong> <?php esc_html_e('First you have create a folder "ilist" in child or parent theme\'s main directory.'); ?></p>
			<p><strong>2.</strong> <?php esc_html_e('Now you have create another folder "templates" inside the "ilist" folder.'); ?></p>
			<p><strong>3.</strong> <?php esc_html_e('Finally you have to copy a template folder (which you need to override) from "iList-pro > views" and paste it inside the "templates" folder which you have created in child or parent theme folder.'); ?></p>
			</div>
		</div>


	
	</div>
	
	<?php
}


function qcilist_pro_title_special_character_clean($string){
    // Replaces all spaces with hyphens.

    $string = strtolower(str_replace(' ', '-', $string));

    // Removes special chars.
    $string = preg_replace('/[^A-Za-z0-9\-]/', '', $string);
    // Replaces multiple hyphens with single one.
    $string = preg_replace('/-+/', '-', $string);
    
    return $string;
}