<?php 

defined('ABSPATH') or die("No direct script access!");

if(!function_exists('qcilist_pro_meme_custom_post_text')){
	function qcilist_pro_meme_custom_post_text() {

		$args = array(
		  		'labels'	=>	array(
								'name'               	=> 	'Build Meme',
								'all_items' 			=> 	'Build Meme',
								'menu_name'				=>	'Build Meme',
								'singular_name' 		=>	'Build Meme',
								'add_new'       		=>  'New Meme',
								'add_new_item'  		=> 	'Add New Meme',
							 	'edit_item' 			=>	'Edit Build Meme',
							 	'new_item'  			=>	'New Build Meme',
							 	'view_item' 			=>	'View Build Meme',
							 	'items_archive' 		=>	'Build Meme Archive',
							 	'search_items'  		=>	'Search Build Memes',
							 	'not_found'	    		=>	'No Build Memes found.',
							 	'not_found_in_trash'  	=> 'No Build Memes found in trash.'
							),
			'supports'      =>	array( 'title' ),				
			'show_in_menu'  =>	'edit.php?post_type=ilist',
			'public'		    =>	true
		);
		register_post_type( 'ilist_meme', $args );

	}
}
add_action('init', 'qcilist_pro_meme_custom_post_text');


//Custom Columns for Directory Listing
if(!function_exists('qcilist_pro_meme_text_list_column_head')){
	function qcilist_pro_meme_text_list_column_head($defaults) {

	    $new_columns['cb'] = '<input type="checkbox" />';
	    $new_columns['title'] = __('Title');
	    $new_columns['qcld_ilist_meme_shortcode'] = 'Shortcode';
	    $new_columns['date'] = __('Date');
	    return $new_columns;

	}
}
 
//Custom Columns Data for Backend Listing
if(!function_exists('qcilist_pro_meme_list_text_columns_content')){
	function qcilist_pro_meme_list_text_columns_content($column_name, $post_ID) {

	    if ($column_name == 'qcld_ilist_meme_shortcode') {
	        echo '[qcld-ilist-meme list_id="'.$post_ID.'" ]';
	    }

	}
}

add_filter('manage_ilist_meme_posts_columns', 'qcilist_pro_meme_text_list_column_head');
add_action('manage_ilist_meme_posts_custom_column', 'qcilist_pro_meme_list_text_columns_content', 10, 2);


if(!function_exists('qcilist_pro_meme_add_custom_meta_boxs')){
	function qcilist_pro_meme_add_custom_meta_boxs(){

	    add_meta_box("qc_ilist_meme-meta-box", "Meme Build", "qcilist_pro_meme_custom_meta_box_markups", "ilist_meme");

	}
}
add_action("add_meta_boxes", "qcilist_pro_meme_add_custom_meta_boxs");

if(!function_exists('qcilist_pro_meme_custom_meta_box_markups')){
	function qcilist_pro_meme_custom_meta_box_markups($object){

	    ?>
	        <div>
	            <?php 

		            if(isset($object->ID) && !empty($object->ID)): 

		            	$qcld_ilist_shortcode =  qcilist_pro_meme_template_function_callback(); 
						echo $qcld_ilist_shortcode;
		            
		        	endif; 

	        	?>

	        </div>

	    <?php  
	}
}


if(!function_exists('qcilist_pro_meme_template_function_callback')){

	function qcilist_pro_meme_template_function_callback(){

		global $post;
	    if( isset( $post->post_type ) && ( 'ilist_meme' === $post->post_type ) ){
	        $post_id = $post->ID;

	        $qcilist_pro_meme_canvas_img = get_post_meta( $post_id, 'qcilist_pro_meme_canvas_img', true );

		?>

		<div class="qcld-ilist-meme-container_wrap">
		 
			<div class="qcilist_pro_meme_container">
			  <h1><?php esc_html_e('CREATE YOUR OWN MEME', 'qc-opd'); ?></h1>
			  <p><?php esc_html_e('Upload an image, type in some lines and save', 'qc-opd'); ?></p>
			  <div id="qcilist_pro_meme_build">
			  	<div class="qcilist_pro_meme_canvas_wrap">

			  	<?php 

			  	$meme_build_template = get_post_meta( $post_id, 'qcld_ilist_meme_publish_in_data', true );

			  	if(!empty($post_id) && !empty($meme_build_template)):

			  		echo $meme_build_template;

			  	else: 
			  	?>
				    <div class="qcilist_pro_meme_canvas_wrao" id="qcilist_pro_meme_canvas_wrao">
				    	<div class="qcilist_pro_meme_canvas_img_wrap">
				    		<img src="<?php echo esc_url(plugins_url( 'assets/images/select-image.jpg', __FILE__ )); ?>" id="qcilist_pro_meme_canvas_img_path" >
				    	</div>
				    	<div class="qcilist_pro_meme_canvas_img_con">
							<p class="qcilist_pro_meme_canvas_line_one"></p>
							<p class="qcilist_pro_meme_canvas_line_two"></p>
						</div>
						<input type="hidden" id="qcilist_pro_meme_canvas_img" name="qcilist_pro_meme_canvas_img" value="" >
					</div>
			  	<?php  endif; ?>
					</div>
			    <div class="qcilist_pro_meme_inputs">
					<input id="qcilist_pro_meme_toplinetext" name="qcilist_pro_meme_toplinetext" type="text" value="<?php echo get_post_meta( $post_id, 'qcilist_pro_meme_toplinetext', true ); ?>" placeholder="<?php esc_html_e('TOP LINE', 'qc-opd'); ?>"><br/>
					<br/>
					<input id="qcilist_pro_meme_bottomlinetext" name="qcilist_pro_meme_bottomlinetext" type="text" value="<?php echo get_post_meta( $post_id, 'qcilist_pro_meme_bottomlinetext', true ); ?>" placeholder="<?php esc_html_e('BOTTOM LINE', 'qc-opd'); ?>">
					<br/>

					<div class="qcld-ilist-meme-image-upload">
	                    <input type="hidden" name="qcld_ilist_meme_image_upload_path" id="qcld_ilist_meme_image_upload_path" value=""/>
	                    <button type="button" class="qcld_ilist_meme_image_upload button"> <?php esc_html_e('Upload  Image', 'qc-opd'); ?> </button>
					</div>
			    </div>
			    <div class="qcilist_pro_meme_pixel_image_wrap">
			    	<div class="qcilist_pro_meme_pixel_image_title"><?php esc_html_e('Pexels Photo', 'qc-opd'); ?></p>
					<input type="text" placeholder="<?php esc_html_e('Search Pexels Photo', 'qc-opd'); ?>">
					<div id="qcilist_pro_meme_pixel_image_show" class="qcilist_pro_meme_pixel_image_show"></div>
			    </div>
			  </div>
			</div>

			<input type="hidden" name="qcld_ilist_meme_publish_in_data" class="qcld_ilist_meme_publish_in_data"  value=""/>

		</div>

		<?php

		}

	}

}



add_action( 'save_post', 'qcld_ilist_meme_save_custom_post_type');
if(!function_exists('qcld_ilist_meme_save_custom_post_type')){
	function qcld_ilist_meme_save_custom_post_type($postid){  

	    if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return false;
	    if ( !current_user_can( 'edit_page', $postid ) ) return false;
	    if(empty($postid) || (isset($_POST['post_type']) != 'ilist_meme' )) return false;

	    if($_POST['action'] == 'editpost'){

		    if(isset($_POST['qcilist_pro_meme_toplinetext']) && !empty($_POST['qcilist_pro_meme_toplinetext']) ){

		        delete_post_meta($postid, 'qcilist_pro_meme_toplinetext');
		    	add_post_meta($postid, 'qcilist_pro_meme_toplinetext', sanitize_text_field($_POST['qcilist_pro_meme_toplinetext']));
		    }

		    if(isset($_POST['qcilist_pro_meme_bottomlinetext']) && !empty($_POST['qcilist_pro_meme_bottomlinetext']) ){

		        delete_post_meta($postid, 'qcilist_pro_meme_bottomlinetext');
		    	add_post_meta($postid, 'qcilist_pro_meme_bottomlinetext', sanitize_text_field($_POST['qcilist_pro_meme_bottomlinetext']));
		    }

		    if(isset($_POST['qcld_ilist_meme_publish_in_data']) && !empty($_POST['qcld_ilist_meme_publish_in_data']) ){

		    	delete_post_meta($postid, 'qcld_ilist_meme_publish_in_data');
		    	add_post_meta($postid, 'qcld_ilist_meme_publish_in_data', $_POST['qcld_ilist_meme_publish_in_data']);
		    }

		    if(isset($_POST['qcilist_pro_meme_canvas_img']) && !empty($_POST['qcilist_pro_meme_canvas_img']) ){

		        delete_post_meta($postid, 'qcilist_pro_meme_canvas_img');
		    	add_post_meta($postid, 'qcilist_pro_meme_canvas_img', sanitize_text_field($_POST['qcilist_pro_meme_canvas_img']));
		    }

	    }
	  
	}

}

if(!function_exists('qcld_ilist_meme_admin_style_script')){
	function qcld_ilist_meme_admin_style_script(){
	    global $post_type;

	    if(is_admin()){

			if( (isset($_GET['page']) && ($_GET['page'] == 'ilist_meme')) || ($post_type=='ilist_meme')  ){

				wp_enqueue_style( 'wp-color-picker' );
				wp_enqueue_style( 'qc-ilist-meme-bootstrap-css', QCOPD_ASSETS_URL1 . "/assets/css/meme-style.css");
				wp_enqueue_script( 'qc-ilist-meme-html2canvas-js', QCOPD_ASSETS_URL1 . "/assets/js/html2canvas.js", array('jquery'));

				wp_enqueue_script( 'qc-ilist-meme-custom-js', QCOPD_ASSETS_URL1 . "/assets/js/meme-custom-scripts.js", array('jquery', 'wp-color-picker'));
	            wp_enqueue_media();

			 	$qcld_ajax = array(
		                'admin_url'                 	=> admin_url( 'admin-ajax.php', is_ssl() ? 'https' : 'http' ),
		                'QCOPD_ASSETS_URL1'         	=> QCOPD_ASSETS_URL1,
		                'QCOPD_IMG_URL1'         		=> QCOPD_IMG_URL1,
		                'meme_images_security_nonce'    => wp_create_nonce('qcld_ilist_meme_images_security_nonce'),
		            );
		    	wp_localize_script( 'qc-ilist-meme-custom-js', 'qcld_ilist_drag_ajax', $qcld_ajax );

			}else if( ($post_type =='page') &&  ($post_type !='ilist_meme') ){

				wp_enqueue_style( 'wp-color-picker' );
				wp_enqueue_style( 'qc-ilist-meme-bootstrap-css', QCOPD_ASSETS_URL1 . "/assets/css/meme-style.css");
				wp_enqueue_script( 'qc-ilist-meme-html2canvas-js', QCOPD_ASSETS_URL1 . "/assets/js/html2canvas.js", array('jquery'));

				wp_enqueue_script( 'qc-ilist-meme-custom-js', QCOPD_ASSETS_URL1 . "/assets/js/meme-generator-custom-scripts.js", array('jquery', 'wp-color-picker'));
	            wp_enqueue_media();

			 	$qcld_ajax = array(
		                'admin_url'                 	=> admin_url( 'admin-ajax.php', is_ssl() ? 'https' : 'http' ),
		                'QCOPD_ASSETS_URL1'         	=> QCOPD_ASSETS_URL1,
		                'QCOPD_IMG_URL1'         		=> QCOPD_IMG_URL1,
		                'meme_images_security_nonce'    => wp_create_nonce('qcld_ilist_meme_images_security_nonce'),
		            );
		    	wp_localize_script( 'qc-ilist-meme-custom-js', 'qcld_ilist_drag_ajax', $qcld_ajax );

			}

		}

	}
}
add_action( 'admin_enqueue_scripts', 'qcld_ilist_meme_admin_style_script' );



//Shortcode area
add_shortcode('qcld-ilist-meme', 'qcld_ilist_meme_full_shortcode');

function qcld_ilist_meme_full_shortcode( $atts = array() ){

	ob_start();

	//Defaults & Set Parameters
	extract( shortcode_atts(
		array(
			'orderby' => 'title',
			'list_id' => '',
			'mode' => '',
		), $atts
	));


	$limit = 1;	
	$orderby = 'title';	
	$order = 'ASC';	

	//Query Parameters
	$list_args = array(
		'post_type' 		=> 'ilist_meme',
		'p' 				=> $list_id,
	);

	// The Query
	$list_query = new WP_Query( $list_args );

	// The Loop
	if ( $list_query->have_posts() && !empty($list_id)) {

		while ( $list_query->have_posts() ) {

			$list_query->the_post();
			
			$qcilist_pro_meme_canvas_img = get_post_meta( get_the_ID(), 'qcilist_pro_meme_canvas_img', true );

			echo '<img src="'.$qcilist_pro_meme_canvas_img.'" alt="">';

		}

	}else{
		echo "<div>
				<p>".esc_html('No iList was found.')."</p>
			</div>";
	}



    $content = ob_get_clean();
    return $content;
}


add_action('admin_init', 'register_ilist_meme_images_options');

function register_ilist_meme_images_options(){
    register_setting('ilist_meme_images_options', 'ilist_meme_images_options', 'ilist_meme_images_options_validate');
}


/* validate settings */

function ilist_meme_images_options_validate($input){
    global $ilist_meme_images_images_gallery_languages;
    $options = get_option('ilist_meme_images_options');
    if ($input['attribution']) $options['attribution'] = 'true'; else $options['attribution'] = 'false';
    return $options;
}


/* Download and upload the chosen image */
if (isset($_POST['qcld_ilist_meme_images_upload'])) {
	// "pluggable.php" is required for wp_verify_nonce() and other upload related helpers
	if (!function_exists('wp_verify_nonce'))
		require_once(ABSPATH . 'wp-includes/pluggable.php');

	$nonce = $_POST['wpnonce'];
	if (!wp_verify_nonce($nonce, 'qcld_ilist_meme_images_security_nonce')) {
		die('Error: Invalid request.');
		exit;
	}

	$post_id     = isset($_REQUEST['post_id']) ? absint($_REQUEST['post_id']): '';
	$ilist_meme_images_images_settings = get_option('ilist_meme_images_options');

	/* get image file */
	$response = wp_remote_get(esc_url($_POST['image_url']));
	if (is_wp_error($response))
		die('Error: ' . $response->get_error_message());

	$q_tags = explode(' ', sanitize_text_field($_POST['q']));
	array_splice($q_tags, 2);
	foreach ($q_tags as $k => $v) {
		// remove ../../../..
		$v          = str_replace("..", "", $v);
		$v          = str_replace("/", "", $v);
		$q_tags[$k] = sanitize_file_name($v);
	}
	/* Name the file. */
	$path_info = isset($_POST['image_url']) ? pathinfo(esc_url($_POST['image_url'])) : '';
	$file_name = sanitize_file_name(implode('_', $q_tags) . '_' . time() . '.' . $path_info['extension']);

	//var_dump($file_name);
	

	$wp_upload_dir     = wp_upload_dir();
	$image_upload_path = $wp_upload_dir['path'];

	if (!is_dir($image_upload_path)) {
		if (!@mkdir($image_upload_path, 0777, true))
			die('Error: Failed to create upload folder ' . $image_upload_path);
	}

	$target_file_name = $image_upload_path . '/' . $file_name;
	$result           = @file_put_contents($target_file_name, $response['body']);
	unset($response['body']);
	if ($result === false)
		die('Error: Failed to write file ' . $target_file_name);

	/* Check/verify that we are dealing with an image only */
	require_once(ABSPATH . 'wp-admin/includes/image.php');
	if (!wp_read_image_metadata($target_file_name)) {
		unlink($target_file_name);
		die('Error: File is not an image.');
	}

	/* add the image title */
	$image_title = ucwords(implode(', ', $q_tags));

	/* add the caption */
	$attachment_caption = '';
	if (! isset($ilist_meme_images_images_settings['attribution']) | isset($ilist_meme_images_images_settings['attribution']) == 'true')
		$attachment_caption = '<a href="' . esc_url($_POST['image_src_page']) . '" target="_blank" rel="noopener">' . sanitize_text_field($_POST['image_user']) . '</a> at Pexels';

	/* insert the attachment */
	$wp_filetype = wp_check_filetype(basename($target_file_name), null);
	$attachment  = array(
		'guid' => $wp_upload_dir['url'] . '/' . basename($target_file_name),
		'post_mime_type' => $wp_filetype['type'],
		'post_title' => preg_replace('/\.[^.]+$/', '', $image_title),
		'post_status' => 'inherit'
	);
	$attach_id   = wp_insert_attachment($attachment, $target_file_name, $post_id);
	if ($attach_id == 0)
		die('Error: File attachment error');

	$attach_data = wp_generate_attachment_metadata($attach_id, $target_file_name);
	$result      = wp_update_attachment_metadata($attach_id, $attach_data);

	$image_data                 = array();
	$image_data['ID']           = $attach_id;
	$image_data['post_excerpt'] = $attachment_caption;
	wp_update_post($image_data);

	$parsed = wp_get_attachment_image_src( $attach_id, 'medium' )[0];

	if(!empty($parsed)){
		$attach_id = $parsed;
	}

	echo $attach_id;
	exit;
}



/* Download and upload the chosen image */
if (isset($_POST['qcld_ilist_meme_image_save'])) {
	// "pluggable.php" is required for wp_verify_nonce() and other upload related helpers
	if (!function_exists('wp_verify_nonce'))
		require_once(ABSPATH . 'wp-includes/pluggable.php');

	$nonce = $_POST['wpnonce'];
	if (!wp_verify_nonce($nonce, 'qcld_ilist_meme_images_security_nonce')) {
		die('Error: Invalid request.');
		exit;
	}

	/* get image file */
	//$response = wp_remote_get(esc_url($_POST['image_url']));
	$base64_img = isset($_POST['image_url']) ? $_POST['image_url'] : '';
	$title 	    = isset($_POST['image_title']) ? sanitize_text_field($_POST['image_title']) : '';
	

	$upload_dir       = wp_upload_dir();

	// @new
	$upload_path      = str_replace( '/', DIRECTORY_SEPARATOR, $upload_dir['path'] ) . DIRECTORY_SEPARATOR;

	$img = $_POST['image_url'];
	$img = str_replace('data:image/png;base64,', '', $img);
	$img = str_replace(' ', '+', $img);

	$decoded          = base64_decode($img) ;
	$filename         = $title.'.png';
	$hashed_filename  = md5( $filename . microtime() ) . '_' . $filename;
	// @new
	$image_upload     = file_put_contents( $upload_path . $hashed_filename, $decoded );

	//HANDLE UPLOADED FILE
	if( !function_exists( 'wp_handle_sideload' ) ) {
	  require_once( ABSPATH . 'wp-admin/includes/file.php' );
	}

	// Without that I'm getting a debug error!?
	if( !function_exists( 'wp_get_current_user' ) ) {
	  require_once( ABSPATH . 'wp-includes/pluggable.php' );
	}

	// @new
	$file             = array();
	$file['error']    = '';
	$file['tmp_name'] = $upload_path . $hashed_filename;
	$file['name']     = $hashed_filename;
	$file['type']     = 'image/png';
	$file['size']     = filesize( $upload_path . $hashed_filename );

	// upload file to server
	// @new use $file instead of $image_upload
	$file_return      = wp_handle_sideload( $file, array( 'test_form' => false ) );

	$filename = $file_return['file'];
	$attachment = array(
		'post_mime_type' => $file_return['type'],
		'post_title' => preg_replace('/\.[^.]+$/', '', basename($filename)),
		'post_content' => '',
		'post_status' => 'inherit',
		'guid' => $upload_dir['url'] . '/' . basename($filename)
	);
	$attach_id = wp_insert_attachment( $attachment, $filename, 289 );
	require_once(ABSPATH . 'wp-admin/includes/image.php');
	$attach_data = wp_generate_attachment_metadata( $attach_id, $filename );
	wp_update_attachment_metadata( $attach_id, $attach_data );

	echo $upload_dir['url'] . '/' . basename($filename);
	exit;
}

// Setting a custom timeout value for cURL. Using a high value for priority to ensure the function runs after any other added to the same action hook.
add_action('http_api_curl', 'qcld_ilist_meme_custom_curl_timeout', 9999, 1);
function qcld_ilist_meme_custom_curl_timeout( $handle ){
	curl_setopt( $handle, CURLOPT_CONNECTTIMEOUT, 150 ); // 30 seconds. Too much for production, only for testing.
	curl_setopt( $handle, CURLOPT_TIMEOUT, 150 ); // 30 seconds. Too much for production, only for testing.
}

// Setting custom timeout for the HTTP request
add_filter( 'http_request_timeout', 'qcld_ilist_meme_custom_http_request_timeout', 9999 );
function qcld_ilist_meme_custom_http_request_timeout( $timeout_value ) {
	return 150; // 30 seconds. Too much for production, only for testing.
}

// Setting custom timeout in HTTP request args
add_filter('http_request_args', 'qcld_ilist_meme_custom_http_request_args', 9999, 1);
function qcld_ilist_meme_custom_http_request_args( $r ){
	$r['timeout'] = 150; // 30 seconds. Too much for production, only for testing.
	return $r;
}




add_action( 'add_meta_boxes', 'qcld_ilist_meme_meta_box_for_use_shortcode' );
function qcld_ilist_meme_meta_box_for_use_shortcode(){	
				                  // --- Parameters: ---
    add_meta_box( 'qc-meme-meta-box-id', // ID attribute of metabox
                  'Meme Generator',       // Title of metabox visible to user
                  'qcld_ilist_meme_meta_box_callback', // Function that prints box in wp-admin
                  'page',              // Show box for posts, pages, custom, etc.
                  'side',            // Where on the page to show the box
                  'high' );            // Priority of box in display order
}

function qcld_ilist_meme_meta_box_callback( $post ){
    ?>
    <p>
        <label for="sh_meta_box_bg_effect"><p> <?php esc_html_e('Click the button below to generate Meme', 'qc-opd'); ?></p></label>
		<input type="button" id="qcld_ilist_meme_generator_meta" class="button button-primary button-large" value="<?php esc_html_e('Generate Meme', 'qc-opd'); ?>" />
    </p>
    
    <?php
}

function qcld_ilist_meme_render_shortcode_modal() {
	?>
	<div id="sm-modal" class="ilistmodal ilistmememodal">
		<!-- Modal content -->
		<div class="modal-content">
			<span class="close">×</span>
			<h3><img src="<?php echo esc_url(plugins_url( 'assets/images/1.png', __FILE__ )); ?>" alt="sdf"> <?php esc_html_e( ' - Meme Generators' , 'qc-opd' ); ?></h3>
			<hr/>
			<div class="ilist_meme_container_area">
				<div class="qcld-ilist-meme-container_wrap">
					<div class="qcilist_pro_meme_container">
					  <h1><?php esc_html_e('CREATE YOUR OWN MEME', 'qc-opd'); ?></h1>
					  <p><?php esc_html_e('Upload an image, type in some lines and save', 'qc-opd'); ?></p>
					  <div id="qcilist_pro_meme_build">
					  	<div class="qcilist_pro_meme_canvas_wrap">
						    <div class="qcilist_pro_meme_canvas_wrao" id="qcilist_pro_meme_canvas_wrao">
						    	<div class="qcilist_pro_meme_canvas_img_wrap">
						    		<img src="<?php echo esc_url(plugins_url( 'assets/images/select-image.jpg', __FILE__ )); ?>" id="qcilist_pro_meme_canvas_img_path" >
						    	</div>
						    	<div class="qcilist_pro_meme_canvas_img_con">
									<p class="qcilist_pro_meme_canvas_line_one"></p>
									<p class="qcilist_pro_meme_canvas_line_two"></p>
								</div>
								<input type="hidden" id="qcilist_pro_meme_canvas_img" name="qcilist_pro_meme_canvas_img" value="" >
							</div>
							</div>
					    <div class="qcilist_pro_meme_inputs">
							<input id="qcilist_pro_meme_toplinetext" name="qcilist_pro_meme_toplinetext" type="text" value="" placeholder="<?php esc_html_e('TOP LINE', 'qc-opd'); ?>"><br/>
							<br/>
							<input id="qcilist_pro_meme_bottomlinetext" name="qcilist_pro_meme_bottomlinetext" type="text" value="" placeholder="<?php esc_html_e('BOTTOM LINE', 'qc-opd'); ?>">
							<br/>
							<div class="qcld-ilist-meme-image-upload">
			                    <input type="hidden" name="qcld_ilist_meme_image_upload_path" id="qcld_ilist_meme_image_upload_path" value=""/>
			                    <button type="button" class="qcld_ilist_meme_image_upload button"> <?php esc_html_e('Upload  Image', 'qc-opd'); ?> </button>
							</div>
					    </div>
					    <div class="qcilist_pro_meme_pixel_image_wrap">
					    	<div class="qcilist_pro_meme_pixel_image_title"><?php esc_html_e('Pexels Photo', 'qc-opd'); ?></p>
							<input type="text" placeholder="<?php esc_html_e('Search Pexels Photo', 'qc-opd'); ?>">
							<div id="qcilist_pro_meme_pixel_image_show" class="qcilist_pro_meme_pixel_image_show"></div>
					    </div>
					  </div>
					</div>
					<input type="hidden" name="qcld_ilist_meme_publish_in_data" class="qcld_ilist_meme_publish_in_data"  value=""/>
				</div>
			</div>
			<div class="ilist_meme_shortcode_container_publish" style="display:none;">
				<div class="ilist_meme_single_field_shortcode">
	                <button class="ilist_meme_image_publish button button-primary button-small" style="float:right">  <?php esc_html_e('Publish', 'qc-opd'); ?></button></p>
	            </div>
			</div>
			<div class="ilist_meme_shortcode_container" style="display:none;">
				<div class="ilist_meme_single_field_shortcode">
	                <textarea id="ilist_meme_shortcode_container"></textarea>
					<p><b> <?php esc_html_e('Copy', 'qc-opd'); ?></b>  <?php esc_html_e('the shortcode & use it any text block.', 'qc-opd'); ?> <button class="ilist_meme_copy_close button button-primary button-small" style="float:right"> <?php esc_html_e('Copy & Close', 'qc-opd'); ?> </button></p>
	            </div>
			</div>
		</div>
	</div>
	<?php

	exit;

}
add_action( 'wp_ajax_meme_show_shortcodes', 'qcld_ilist_meme_render_shortcode_modal');